/*******************************************************************************
modulo: 					nRF24L01.h (TX - RX)
versione : 					1.4 (Laurtec)
autore: 					Marcello Pinna
data:  						05/02/2018

CopyRight 2018 				all rights are reserved
*******************************************************************************/

#ifndef NRF24L01_H
#define	NRF24L01_H

//***************************************************************************
//  DEFINE
//***************************************************************************
#define NRF24L01_CE         LATEbits.LATE0
#define NRF24L01_TRIS_CE    TRISEbits.TRISE0

#define NRF24L01_CSN        LATEbits.LATE2
#define NRF24L01_TRIS_CSN   TRISEbits.TRISE2

// Numero di byte da inviare o leggere
#define PAYLOAD_BYTES       2 

//***************************************************************************
//  MAPPA DEL REGISTRO 
//***************************************************************************
//		Mnemonic			value
#define R_REGISTER          0x00  
#define W_REGISTER          0x20  
#define R_RX_PAYLOAD        0x61  
#define W_TX_PAYLOAD        0xA0  
#define FLUSH_TX            0xE1  
#define FLUSH_RX            0xE2  
#define REUSE_TX_PL         0xE3  

#define CONFIG              0x00  
#define EN_AA               0x01  
#define EN_RXADDR           0x02  
#define SETUP_AW            0x03  
#define SETUP_RETR          0x04  
#define RF_CH               0x05  
#define RF_SETUP            0x06  
#define STATUS              0x07  
#define OBSERVE_TX          0x08  
#define CD                  0x09  
#define RX_ADDR_P0          0x0A  
#define RX_ADDR_P1          0x0B  
#define RX_ADDR_P2          0x0C  
#define RX_ADDR_P3          0x0D  
#define RX_ADDR_P4          0x0E  
#define RX_ADDR_P5          0x0F  
#define TX_ADDR             0x10  
#define RX_PW_P0            0x11  
#define RX_PW_P1            0x12  
#define RX_PW_P2            0x13  
#define RX_PW_P3            0x14  
#define RX_PW_P4            0x15  
#define RX_PW_P5            0x16  
#define FIFO_STATUS         0x17  

//***************************************************************************
//  PROTOTIPI DI FUNZIONE
//***************************************************************************
void Setup_CE_CSN (void);
void Enable_PWR_UP_CRC (void);
void Enable_AUTO_ACK (void);
void Enable_DATAPIPE (void);
void Setup_ADDRESS_WIDTH (void);
void Disable_RETRANSMISSION (void);
void Setup_CHANNEL (void);
void Setup_MPS_DB (void);
void Setup_WRITING_ADDRESS (void);
void Setup_READING_ADDRESS (void);
void Setup_RX_PAYLOAD (void);
void Clear_BUFFER_TX_RX (void);
void Clear_STATUS_reg (void);
void Setup_TX_Mode (void);
void Setup_RX_Mode (void);
unsigned char NRF24L01_DataReady (void);
void NRF24L01_Init_TX (void);
void NRF24L01_Init_RX (void);

#endif	/* NRF24L01_H */

